#include <bits/stdc++.h>

using namespace std;
#define int long long

void ckmin(int &a, int b) {
    if (b < a) {
        a = b;
    }
}

const int N = 1e6 + 7;
int cnt[N], mn[N << 2], prop[N << 2], sum[N << 2];

void relax_min(int v) {
    sum[v] = sum[v * 2 + 1] + sum[v * 2 + 2];
}

void gap(int v, int l, int r, int x) {
    int len = r - l + 1;
    sum[v] = x * len;
}

void push(int v, int l, int r, int m) {
    if (prop[v] != -1) {
        gap(v * 2 + 1, l, m, prop[v]);
        gap(v * 2 + 2, m + 1, r, prop[v]);
        prop[v] = -1;
    }
}

void setval(int v, int l, int r, int ql, int qr, int x) {
    if (r < ql || qr < l) {
        return;
    }
    if (ql <= l && r <= qr) {
        gap(v, l, r, x);
        return;
    }
    int m = (l + r) / 2;
    push(v, l, r, m);
    setval(v * 2 + 1, l, m, ql, qr, x);
    setval(v * 2 + 2, m + 1, r, ql, qr, x);
    relax_min(v);
}

void build_min(int v, int l, int r) {
    if (l == r) {
        sum[v] = mn[l];
        return;
    }
    int m = (l + r) / 2;
    build_min(v * 2 + 1, l, m);
    build_min(v * 2 + 2, m + 1, r);
    relax_min(v);
}

void relax_cnt(int v) {
    mn[v] = min(mn[v * 2 + 1], mn[v * 2 + 2]);
}

void build_cnt(int v, int l, int r) {
    if (l == r) {
        mn[v] = cnt[l];
        return;
    }
    int m = (l + r) / 2;
    build_cnt(v * 2 + 1, l, m);
    build_cnt(v * 2 + 2, m + 1, r);
    relax_cnt(v);
}

void setcnt(int v, int l, int r, int i, int x) {
    if (l == r) {
        mn[v] = x;
        return;
    }
    int m = (l + r) / 2;
    if (i <= m) {
        setcnt(v * 2 + 1, l, m, i, x);
    } else {
        setcnt(v * 2 + 2, m + 1, r, i, x);
    }
    relax_cnt(v);
}

int getmin_cnt(int v, int l, int r, int ql, int qr) {
    if (qr < l || r < ql) {
        return N;
    }
    if (ql <= l && r <= qr) {
        return mn[v];
    }
    int m = (l + r) / 2;
    return min(getmin_cnt(v * 2 + 1, l, m, ql, qr), getmin_cnt(v * 2 + 2, m + 1, r, ql, qr));
}

int leftless(int v, int l, int r, int from, int x) {
    if (mn[v] >= x || r < from) {
        return N;
    }
    if (l == r) {
        return l;
    }
    int m = (l + r) / 2;
    int t = leftless(v * 2 + 1, l, m, from, x);
    if (t != N) {
        return t;
    } else {
        return leftless(v * 2 + 2, m + 1, r, from, x);
    }
}

struct pt {
    int x, y;

    pt operator-(pt p) const { return {x - p.x, y - p.y}; }

    pt operator*(int k) const {
        return {x * k, y * k};
    }

    friend bool line(pt a, pt b, pt c) { return cross(a - b, c - b)==0; }

    bool on(pt u, pt v) { return scalar(*this - u, v - u) > 0 && scalar(*this - v, u - v) > 0 && line(*this, u, v); }

    friend int scalar(pt v, pt u) { return v.x * u.x + v.y * u.y; }

    friend int cross(pt v, pt u) { return v.x * u.y - v.y * u.x; }

    bool operator<(pt p) const { return pair{x, y} < pair{p.x, p.y}; }
};

void solve() {
    int n;
    cin >> n;
    vector<pair<pt, pt>> s(n);
    for (auto &[u, v]: s) cin >> u.x >> u.y >> v.x >> v.y;
    int ans = 0;
    for (auto [u, v]: s) {
        map<pt, vector<pt>> onL, onR;
        for (auto [p, q]: s) {
            if (cross(p - q, v - u) == 0) continue;
            if (q.on(u, v)) swap(p, q);
            if (q.on(u, v)) continue;
            if (!p.on(u, v)) continue;
            (cross(q - p, v - u) > 0 ? onR : onL)[p].push_back(q);
        }
        for (auto &o : {onL, onR}) for (auto [p, vq]: o) {
            sort(vq.begin(), vq.end(), [&](auto p1, auto p2) { return cross(p1-p, p2-p) > 0; });
            vector<int> type(vq.size());
            map<int, int> cnt;
            for (int i = 1; i < vq.size(); ++i) {
                type[i] = type[i - 1] + !(line(p, vq[i - 1], vq[i]));
            }
            for (int i = 0; i < vq.size(); ++i) {
                ans += i - cnt[type[i]];
                cnt[type[i]]++;
            }
        }
    }
    cout << ans << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    do {
        solve();
    } while (--t);
}
/*
 * 2
5
0 0 0 10
0 5 3 10
0 5 3 0
0 5 7 4
0 5 6 2
8
0 0 10 10
3 4 4 4
4 4 4 5
3 4 4 4
7 7 7 8
7 7 8 7
5 5 4 6
5 5 3 7

 */