#include <bits/stdc++.h>
#define int long long

using namespace std;

struct point {
    int x, y;

    point() {}

    point(int x, int y): x(x), y(y) {}

    void init() {
        cin >> x >> y;
    }

    point operator + (point other) {
        return point(x + other.x, y + other.y);
    }
    point operator - (point other) {
        return point(x - other.x, y - other.y);
    }
    int operator * (point other) {
        return x * other.x + y * other.y;
    }
    int operator ^ (point other) {
        return x * other.y - y * other.x;
    }
};

bool point_on_segment(point a, point b, point x) {
    point v = b - a;
    if ((v ^ (x - a)) != 0)
        return 0;
    return ((a - x) * (b - x)) < 0;
}

struct cmp{
    operator()(const point& lhs, const point &rhs) const {
        if (lhs.x != rhs.x) {
            return lhs.x < rhs.x;
        }
        return lhs.y < rhs.y;
    }
};

bool halfplane(point v) {
    return make_pair(v.x, v.y) > make_pair(0ll, 0ll);
}

bool cmp2(point a, point b) {
    if (halfplane(a) != halfplane(b)) {
        return halfplane(a) > halfplane(b);
    }
    return (a ^ b) > 0;
}

bool eq(point a, point b) {
    return !cmp2(a, b) && !cmp2(b, a);
}

map <point, vector<point>, cmp> rays;
map <point, vector<point>, cmp> longsides;

void solve() {
    rays.clear();
    longsides.clear();
    int n;
    cin >> n;
    vector <pair <point, point>> segms(n);
    for (int i = 0; i < n; i++) {
        point l, r;
        l.init();
        r.init();
        segms[i] = {l, r};
        rays[l].push_back(r - l);
        rays[r].push_back(l - r);
    }
    for (int i = 0; i < n; i++) {
        for (auto const &[p, v] : rays) {
            if (point_on_segment(segms[i].first, segms[i].second, p))
                longsides[p].push_back(segms[i].second - p);
        }
    }

    long long ans = 0;
    for (auto [p, lsides] : longsides) {
        auto ssides = rays[p]; 
        //sort(lsides.begin(), lsides.end(), cmp2); 
        //sort(ssides.begin(), ssides.end(), cmp2);
        for (auto lside : lsides) {
            long long cnt_le = 0, cnt_ge = 0;
            for (auto &sside : ssides) {
                long long sgn = sside ^ lside;
                if (sgn > 0)
                    cnt_ge++;
                if (sgn < 0)
                    cnt_le++;
            }
            ans += cnt_le * (cnt_le - 1) / 2;
            ans += cnt_ge * (cnt_ge - 1) / 2;
        }
        sort(ssides.begin(), ssides.end(), cmp2);
        for (int i = 0; i < (int) ssides.size(); i++) {
            int j = i + 1;
            while (j < (int) ssides.size() && eq(ssides[j], ssides[i]))
                j++;
            long long cnt_lside = 0;
            for (auto &lside : lsides) {
                if ((lside ^ ssides[i]) != 0)
                    cnt_lside++;
            }
            long long cnt_sside = j - i;
            //cout << cnt_lside << ' ' << cnt_sside << "\n";
            ans -= cnt_lside * cnt_sside * (cnt_sside - 1) / 2;
            i = j - 1;
        }
    }
    cout << ans << "\n";
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base :: sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++)
        solve();
    return 0;
}
