#include <bits/stdc++.h>

using namespace std;

int const MOD = 998244353;

using ll = long long;

struct mint {
	int val;

	mint(int x = 0) : val(x % MOD) {}

	mint operator+(mint const& other) const {
		mint res{val + other.val};
		if (res.val >= MOD) res.val -= MOD;
		return res;
	}

	mint& operator+=(mint const& other) {
		return *this = *this + other;
	}

	mint operator*(mint const& other) const {
		return mint{int(ll(val) * other.val % MOD)};
	}

	mint& operator*=(mint const& other) {
		return *this = *this * other;
	}
};

mint power(mint x, ll d) {
	mint r = 1;
	while (d) {
		if (d & 1) r *= x;
		x *= x;
		d /= 2;
	}
	return r;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int n, k, s;
	cin >> n >> k >> s;
	vector<int> pos(k);
	for (int& x : pos) {
		cin >> x;
		--x;
	}
	--s;
	int add = n - 1 - s;
	for (int& p : pos) {
		p = (p + add) % n;
	}
	sort(pos.begin(), pos.end());

	vector C(500, vector<mint>(500));
	for (int i = 0; i < 500; ++i) {
		C[i][0] = 1;
		for (int j = 1; j <= i; ++j) {
			C[i][j] = C[i - 1][j - 1] + C[i - 1][j];
		}
	}

	vector dp(k + 1, vector<mint>(k + 1));
	dp[k][0] = 1;

	for (int i = k - 1; i >= 0; --i) {
		mint length = i == 0 ? pos[i] + 1 : pos[i] - pos[i - 1];
		for (int was = 0; was < k - i; ++was) {
			mint pw = 1;
			for (int is = was; is <= k - i - 1; ++is) {
				dp[i][is] +=
					dp[i + 1][was] *
					C[is][was] *
					pw;
					// power(length, is - was);
				pw *= length;
			}
		}
	}

	// for (int i = 0; i <= k; ++i) {
	// 	for (int j = 0; j <= k; ++j) {
	// 		cout << dp[i][j].val << ' ';
	// 	}
	// 	cout << '\n';
	// }

	mint ans = 1;
	mint pw = 1;
	mint in = power(n, MOD - 2);
	for (int i = 1; i <= k; ++i) {
		pw *= in;
		ans += dp[0][i] * pw;
	}

	// cout << (mint(39) * power(36, MOD - 2)).val << '\n';
	cout << ans.val << '\n';
}