#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#define lint int64_t

using namespace std;

vector<lint> pow2;

int string_multi(const vector<char>& line) {
    int amount = 0;
    bool failed = false;
    int prev = -1;
    int current = 0;
    while (current < line.size()) {
        if (line[current] == '#') {
            if (prev == -1 || line[prev] == '.') {}
            else {
                //cerr << current - prev << " ff\n";
                if ((current - prev) % 2 == 0) {
                    failed = true;
                }
            }
            prev = current;
        }
        if (line[current] == '.') {
            if ((current - prev > 1) && (prev == -1 || line[prev] == '.')) {
                amount += 1;
            }
            prev = current;
        }

        current++;
    }

    if (prev == -1 || (prev < line.size() - 1 && line[prev] == '.')) {
        amount += 1;
    }

    if (failed) {
        return -1;
    } else {
        return amount;
    }

}

vector<char> from_col(vector<vector<char>>& data, int col) {
    vector<char> res(data.size());
    for (int i = 0; i < data.size(); i++) {
        res[i] = data[i][col];
    }

    return res;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef _LOCAL
    freopen("../input.txt", "r", stdin);
//    freopen(stdout, 'w', "output.txt");
#endif


    int n;
    cin >> n;
    vector<vector<char>> map(n);
    for (int i = 0; i < n; i++) {
        map[i].resize(n);
        for (int j = 0; j < n; j++) {
            cin >> map[i][j];
        }
    }

    int max_pow = 0;
    bool failed = false;
    for (int i = 0; i < n; i++) {
        int ans1 = string_multi(map[i]);
        int ans2 = string_multi(from_col(map, i));

        if (min(ans1, ans2) == -1) {
            failed = true;
        }
        //cerr << ans1 << ' ' << ans2 << '\n';

        max_pow += ans1 + ans2;
    }

    if (failed) {
        cout << 0;
    } else {
        lint mod = 998244353;
        lint ans = 1;
        for (int i = 0; i < max_pow; i++) {
            ans = (ans * 2) % mod;
        }

        cout << ans;
    }

    return 0;
}
