#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>

#define lint int64_t

using namespace std;

const int iinf = 1e6+1;

struct ST {
    vector<int> mins;
    int n;

    ST(int n) : mins(n * 4, iinf), n(n) {}

    void set(int pos, int v) {
        setr(pos, v, 1, 0, n);
    }

    void setr(int pos, int v, int id, int tl, int tr) {
        if (tl + 1 == tr) {
            mins[id] = v;
            return;
        }
        int tm = (tl + tr) / 2;
        if (pos < tm) {
            setr(pos, v, id * 2, tl, tm);
        } else {
            setr(pos, v, id * 2 + 1, tm, tr);
        }

        mins[id] = min(mins[id * 2], mins[id * 2 + 1]);
    }

    int get(int pos) {
        return getr(pos, 1, 0, n);
    }

    int getr(int pos, int id, int tl, int tr) {
        if (tl + 1 == tr) return mins[id];
        int tm = (tl + tr) / 2;
        if (pos < tm) return getr(pos, id * 2, tl, tm);
        return getr(pos, id * 2 + 1, tm, tr);
    }

    int min_leq(int v) {
        int id = 1;
        int tl = 0;
        int tr = n;

        while (tl + 1 < tr) {
            int tm = (tl + tr) / 2;
            if (mins[2 * id] <= v) {
                tr = tm;
                id  = id * 2;
            } else {
                tl = tm;
                id = id * 2 + 1;
            }
        }

        if (mins[id] <= v) return tl;
        else return tr;
    }

};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

#ifdef _LOCAL
    freopen("../input.txt", "r", stdin);
//    freopen(stdout, 'w', "output.txt");
#endif

    int n;
    cin>> n;
    vector<int> a(n);
    for (auto& i : a) cin >> i;

    ST st(n);
    int prefmin = iinf;
    lint sum = 0;
    for (int i = 0; i < n; i++) {
        st.set(i, a[i]);
        if (prefmin > a[i])
            prefmin = a[i];
        sum += prefmin;
    }

    cout << sum << '\n';


    int q;
    cin >> q;
    for (int q_id = 0; q_id < q; q_id++) {
        int p, v;
        cin >> p >> v;
        int da = (p == 1) ? 1 : -1;

        if (p == 1) {
            // add
            st.set(v, a[v] + 1);
            int old_pos = st.min_leq(a[v]);

//            for (int i = 0; i < n; i++) cerr << st.get(i) << ' ';
//            cerr << '\n' << a[v] << ' ' << old_pos << '\n';


            if (old_pos > v) {
                sum += old_pos - v;
            }
            a[v]++;
        } else {
            // remove
            int new_pos = st.min_leq(a[v] - 1);

//            for (int i = 0; i < n; i++) cerr << st.get(i) << ' ';
//            cerr << '\n' << a[v] - 1 << ' ' << new_pos << '\n';

            if (new_pos > v) {
                sum -= new_pos - v;
            }
            st.set(v, a[v] - 1);
            a[v]--;
        }
        cout << sum << '\n';

    }

    return 0;
}
