#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<string> field(n);
    for (int i = 0; i < n; i++) {
        cin >> field[i];
    }

    vector<vector<int> > left_idx(n);
    for (int i = 0; i < n; i++) {
        left_idx[i].resize(m);
        int last_idx = -1;
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '#') {
                last_idx = j;
            } else {
                left_idx[i][j] = last_idx;
            }
        }
    }

    vector<vector<int> > right_idx(n);
    for (int i = 0; i < n; i++) {
        right_idx[i].resize(m);
        int last_idx = m;
        for (int j = m - 1; j >= 0; j--) {
            if (field[i][j] == '#') {
                last_idx = j;
            } else {
                right_idx[i][j] = last_idx;
            }
        }
    }

    vector<vector<int> > up_idx(n);
    for (int i = 0; i < n; i++) {
        up_idx[i].resize(m);
    }
    for (int j = 0; j < m; j++) {
        int last_idx = -1;
        for (int i = 0; i < n; i++) {
            if (field[i][j] == '#') {
                last_idx = i;
            } else {
                up_idx[i][j] = last_idx;
            }
        }
    }

    vector<vector<int> > down_idx(n);
    for (int i = 0; i < n; i++) {
        down_idx[i].resize(m);
    }
    for (int j = 0; j < m; j++) {
        int last_idx = n;
        for (int i = n - 1; i >= 0; i--) {
            if (field[i][j] == '#') {
                last_idx = i;
            } else {
                down_idx[i][j] = last_idx;
            }
        }
    }

    struct seg_hor {
        int len;
        int i{}, j1{}, j2{};

        seg_hor() : len(0) {}
    };
    struct seg_ver {
        int len;
        int i1{}, i2{}, j{};

        seg_ver() : len(0) {}
    };
    vector<seg_hor> max_hor_1(n);
    vector<seg_hor> max_hor_2(n);
    vector<seg_ver> max_ver_1(m);
    vector<seg_ver> max_ver_2(m);

    int ans = 0;
    int mx1 = 0, mx2 = 0;
    for (int i = 0; i < n; i++) {
        int blocked_j = -1;
        seg_hor mx1_hor, mx2_hor;
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.' && blocked_j < j) {
                int cur = right_idx[i][j] - j;
                if (cur > mx1) {
                    mx2 = mx1;
                    mx1 = cur;
                } else {
                    mx2 = max(mx2, cur);
                }
                if (cur > mx1_hor.len) {
                    mx2_hor = mx1_hor;
                    mx1_hor.len = cur;
                    mx1_hor.i = i;
                    mx1_hor.j1 = j;
                    mx1_hor.j2 = j + cur - 1;
                } else {
                    if (cur > mx2_hor.len) {
                        mx2_hor.len = cur;
                        mx2_hor.i = i;
                        mx2_hor.j1 = j;
                        mx2_hor.j2 = j + cur - 1;
                    }
                }
                blocked_j = right_idx[i][j];
            }
        }
        max_hor_1[i] = mx1_hor;
        max_hor_2[i] = mx2_hor;
    }
    ans = mx1 + mx2;

    mx1 = 0;
    mx2 = 0;
    for (int j = 0; j < m; j++) {
        int blocked_i = -1;
        seg_ver mx1_ver, mx2_ver;
        for (int i = 0; i < n; i++) {
            if (field[i][j] == '.' && blocked_i < i) {
                int cur = down_idx[i][j] - i;
                if (cur > mx1) {
                    mx2 = mx1;
                    mx1 = cur;
                } else {
                    mx2 = max(mx2, cur);
                }
                if (cur > mx1_ver.len) {
                    mx2_ver = mx1_ver;
                    mx1_ver.len = cur;
                    mx1_ver.j = j;
                    mx1_ver.i1 = i;
                    mx1_ver.i2 = i + cur - 1;
                } else {
                    if (cur > mx2_ver.len) {
                        mx2_ver.len = cur;
                        mx2_ver.j = j;
                        mx2_ver.i1 = i;
                        mx2_ver.i2 = i + cur - 1;
                    }
                }
                blocked_i = down_idx[i][j];
            }
        }
        max_ver_1[j] = mx1_ver;
        max_ver_2[j] = mx2_ver;
    }
    ans = max(ans, mx1 + mx2);

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (field[i][j] == '.') {
                int cur = (right_idx[i][j] - left_idx[i][j] - 1) + (i - up_idx[i][j] - 1);
                ans = max(ans, cur);
                cur = (right_idx[i][j] - left_idx[i][j] - 1) + (down_idx[i][j] - i - 1);
                ans = max(ans, cur);
                cur = (right_idx[i][j] - j - 1) + (down_idx[i][j] - up_idx[i][j] - 1);
                ans = max(ans, cur);
                cur = (j - left_idx[i][j] - 1) + (down_idx[i][j] - up_idx[i][j] - 1);
                ans = max(ans, cur);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            if (max_hor_1[i].j1 <= j && j <= max_hor_1[i].j2) {
                if (max_ver_1[j].i1 <= i && i <= max_ver_1[j].i2) {
                    ans = max(ans, max_hor_1[i].len + max_ver_2[j].len);
                    ans = max(ans, max_hor_2[i].len + max_ver_1[j].len);
                } else {
                    ans = max(ans, max_hor_1[i].len + max_ver_1[j].len);
                }
            } else {
                ans = max(ans, max_hor_1[i].len + max_ver_1[j].len);
            }
        }
    }
    cout << ans << '\n';
}

int main() {
    int t;
    cin >> t;
    for (int tt = 0; tt < t; tt++) {
        solve();
    }
    return 0;
}
