//#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define f first
#define s second
#define sz(x) (x).size()
#define add push_back
#define all(x) (x).begin(), (x).end()

const ll INF = 1e9 + 2408;

const int N = 2e5 + 10;
int arr[N], pref[N], t[N * 4];

ll calc_init_ans(int n) {
    pref[0] = arr[0];
    ll ans = pref[0];
    for (int i = 1; i < n; i++) {
        pref[i] = min(pref[i - 1], arr[i]); ans += pref[i];
    }
    return ans;
}

void relax(int v) {
    t[v] = min(t[v * 2], t[v * 2 + 1]);
}

void build(int v, int l, int r) {
    if (l == r) {
        t[v] = arr[l];
        return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m); build(v * 2 + 1, m + 1, r);
    relax(v);
}

int query(int v, int l, int r, int a, int b) {
    if (a > r || l > b) {
        return INF;
    }
    if (a <= l && r <= b) {
        return t[v];
    }
    int m = (l + r) / 2;
    return min(query(v * 2, l, m, a, b), query(v * 2 + 1, m + 1, r, a, b));
}

void update(int v, int l, int r, int p, int x) {
    if (l == r) {
        t[v] += x;
        return;
    }
    int m = (l + r) / 2;
    if (p <= m) {
        update(v * 2, l, m, p, x);
    } else {
        update(v * 2 + 1, m + 1, r, p, x);
    }
    relax(v);
}

int get_next_le(int p, int x) {
    int l = p - 1, r = N - 1;
    while (l + 1 < r) {
        int m = (l + r) / 2;
        if (query(1, 0, N - 1, p, m) <= x) {
            r = m;
        } else {
            l = m;
        }
    }
    return r;
}

void recalc_add_card(int pos, ll &ans) {
    if (pos && query(1, 0, N - 1, 0, pos - 1) <= arr[pos]) {
        return;
    }
    int kek = get_next_le(pos + 1, arr[pos]);
    ans += kek - pos;
}

void recalc_del_card(int pos, ll &ans) {
    if (query(1, 0, N - 1, 0, pos) < arr[pos]) {
        return;
    }
    int kek = get_next_le(pos + 1, arr[pos] - 1);
    ans -= kek - pos;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> arr[i];
    }
    build(1, 0, N - 1);
    ll ans = calc_init_ans(n);
    cout << ans << "\n";
    int q;
    cin >> q;
    for (int i = 0; i < q; i++) {
        int p, v;
        cin >> p >> v;
        if (p == 1) {
            recalc_add_card(v, ans);
            arr[v]++; update(1, 0, N - 1, v, 1);
        } else {
            recalc_del_card(v, ans);
            arr[v]--; update(1, 0, N - 1, v, -1);
        }
        cout << ans << "\n";
    }
}
