#include <bits/stdc++.h>
#define int long long
using namespace std;

int n, m;

int solve1(const vector<string> &s) {
	vector<vector<int>> u(n, vector<int>(m));
	vector<vector<int>> d(n, vector<int>(m));

	for(int j = 0; j < m; j++) {
		int cnt = 0;
		for(int i = n - 1; i >= 0; i--) {
			d[i][j] = cnt;
			if(i < n - 1) d[i][j] = max(d[i][j], d[i + 1][j]);
			if(s[i][j] == '#') cnt = 0;
			else ++cnt;
		}
		cnt = 0;
		for(int i = 0; i < n; i++) {
			u[i][j] = cnt;
			if(i > 0) u[i][j] = max(u[i][j], u[i - 1][j]);
			if(s[i][j] == '#') cnt = 0;
			else ++cnt;
		}
	}

	int ans = 0;

	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++)
			ans = max(ans, u[i][j] + d[i][j]);

	for(int i = 0; i < n; i++) {
		for(int l = 0; l < m; l++) {
			int r = l;
			while(r < m && s[i][r] == '.')
				++r;
			if(l == r) continue;

			for(int k = l; k < r; k++) {
				ans = max(ans, r - l + u[i][k]);
				ans = max(ans, r - l + d[i][k]);
			}
			//cout << l << " " << r << "\n";
			l = r - 1;
		}
	}
	//cout << "solve1: " << ans << "\n";
	return ans;
}

int solve2(const vector<string> &s) {
	vector<int> pf(m);
	for(int j = 0; j < m; j++) {
		int cnt = 0;
		for(int i = 0; i < n; i++) {
			if(s[i][j] == '#') cnt = 0;
			else ++cnt;
			pf[j] = max(pf[j], cnt);
		}
	}
	vector<int> sf = pf;
	for(int j = 1; j < m; j++)
		pf[j] = max(pf[j - 1], pf[j]);
	for(int j = m - 2; j >= 0; j--)
		sf[j] = max(sf[j + 1], sf[j]);
	
	//for(int i = 0; i < m; i++)
	//	cout << sf[i] << " ";
	//cout << endl;

	int ans = 0;

	for(int j = 1; j < m; j++)
		ans = max(ans, pf[j - 1] + sf[j]);

	for(int i = 0; i < n; i++) {
		for(int l = 0; l < m; l++) {
			int r = l;
			while(r < m && s[i][r] == '.') {
				//cout << r << " "
				++r;
			}
			if(l == r) continue;
			if(l > 0)
				ans = max(ans, r - l + pf[l - 1]);
			if(r < m)
				ans = max(ans, r - l + sf[r]);
			//cout << l << " " << r << '\n';
			l = r - 1;
		}
	}
	//cout << "solve2: " << ans << "\n";
	return ans;
}

void transpose(vector<string> &s) {
	vector<string> res(m);
	for(int i = 0; i < m; i++)
		res[i].resize(n);
	for(int i = 0; i < n; i++)
		for(int j = 0; j < m; j++)
			res[j][i] = s[i][j];
	s = res;
	swap(n, m);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	int t; cin >> t;
	while(t--) {
		cin >> n >> m;
		vector<string> s(n);
		for(auto &i : s)
			cin >> i;
			int ans = 0;
		ans = max(ans, solve1(s));
		ans = max(ans, solve2(s));
		transpose(s);
		ans = max(ans, solve1(s));
		ans = max(ans, solve2(s));
		cout << ans << "\n";
	}
	return 0;
}