#include <bits/stdc++.h>
#define int long long
using namespace std;

const int MAXN = 2e5 + 100;
const int INF = 1e9;

int cnt[MAXN];
int tmin[4 * MAXN];
	
void build(int i, int tl, int tr) {
	if (tl + 1 == tr) {
		//cout << i << " " << tl << " " << cnt[tl] << "\n";
		tmin[i] = cnt[tl];
		return;
	}
	int md = (tl + tr) / 2;
	build(i * 2, tl, md);
	build(i * 2 + 1, md, tr);
	tmin[i] = min(tmin[i * 2], tmin[i * 2 + 1]);
}

int fair_first_lesser(int i, int tl, int tr, int target) {
	if (tl + 1 == tr) return tl;
	int md = (tl + tr) / 2;
	if (tmin[i * 2] < target) {
		return fair_first_lesser(i * 2, tl, md, target);
	}
	return fair_first_lesser(i * 2 + 1, md, tr, target);
}

// to = where + 1, where -- после чего ищем меньший
int get_first_lesser(int i, int tl, int tr, int to, int target) {
	//cout << i << " " << tl << " " << tr << " " << to << " " << target << " " << tmin[i] << "\n";
	if (tmin[i] >= target) return -1;
	if (tl + 1 == tr) {
		if (tmin[i] < target) {
			return tl;
		}
		return -1;
	}
	int md = (tl + tr) / 2;
	if (to >= md) {
		return get_first_lesser(i * 2 + 1, md, tr, to, target);
	}
	int ret = get_first_lesser(i * 2, tl, md, to, target);
	//if (i == 1) cout << "ret = " << ret << endl;
	if (ret != -1) return ret;
	return fair_first_lesser(i * 2 + 1, md, tr, target);
}

void change(int i, int tl, int tr, int to, int delta) {
	if (tl + 1 == tr) {
		tmin[i] += delta;
		return;
	}
	int md = (tl + tr) / 2;
	if (to < md) {
		change(i * 2, tl, md, to, delta);
	} else {
		change(i * 2 + 1, md, tr, to, delta);
	}
	tmin[i] = min(tmin[i * 2], tmin[i * 2 + 1]);
}

int get_min(int i, int tl, int tr, int l, int r) {
	if (l <= tl && tr <= r) 
		return tmin[i];
	if (tl >= r || l >= tr) 
		return INF;
	int md = (tl + tr) / 2;
	int ret = get_min(i * 2, tl, md, l, r);
	ret = min(ret, get_min(i * 2 + 1, md, tr, l, r));
	return ret;
}

int get(int i, int tl, int tr, int pos) {
	if (tl + 1 == tr) return tmin[i];
	int md = (tl + tr) / 2;
	if (pos < md) 
		return get(i * 2, tl, md, pos);
	return get(i * 2 + 1, md, tr, pos);
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	int n;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> cnt[i];
	}
	build(1, 0, MAXN);

	// cout << get_first_lesser(1, 0, MAXN, 2, 4) << endl;
	// return 0;
	int res = 0;
	int pref = cnt[0];

	for (int i = 1; i < MAXN; ++i) {
		int curr = cnt[i];
		res += max(0ll, pref - curr) * i;
		pref = min(pref, curr);
	}

	cout << res << "\n";


	auto add_value = [&] (int val) {
		//cout << "add " << val << endl;
		cnt[val]++;
		change(1, 0, MAXN, val, 1);
		int pref_min = get_min(1, 0, MAXN, 0, val);
		if (pref_min < cnt[val]) return;
		// pref_min >= cnt[val]
		int pos = get_first_lesser(1, 0, MAXN, val + 1, cnt[val]);
		// cout << "pref_min = " << pref_min << endl;
		// cout << "pos = " << pos << endl;
		res += (pos - val);
	};

	// add_value(0);
	// cout << res << "\n";
	// add_value(1);
	// cout << res << "\n";

	auto rem_value = [&] (int val) {
		//cout << "rem " << val << endl;
		int pref_min = get_min(1, 0, MAXN, 0, val);
		//cout << "pref_min = " << pref_min << endl;

		// for (int i = 0; i < n; ++i)
		// 	cout << get(1, 0, MAXN, i) << " ";

		if (pref_min >= cnt[val]) {
			// cout << "val + 1 = " << val + 1 << endl;
			// cout << "cnt[val] = " << cnt[val] << endl;
			int pos = get_first_lesser(1, 0, MAXN, val + 1, cnt[val]);
			//cout << "pos = " << pos << endl;
			res -= (pos - val);
		}
		cnt[val]--;
		change(1, 0, MAXN, val, -1);
	};

	int q;
	cin >> q;
	while (q--) {
		int t, a;
		cin >> t >> a;
		if (t == 1) {
			add_value(a); 
		} else {
			rem_value(a);
		}
		cout << res << "\n";
	}

	return 0;
}