#include <bits/stdc++.h>
#define ALL(x) (x).begin(), (x).end()
#define rALL(x) (x).rbegin(), (x).rend()

using namespace std;

using ll = long long;
using ull = unsigned long long;

mt19937 rng(time(0));

bool valid(int x, int y, int n, int m) {
    return x >= 0 && x < n && y >= 0 && y < m;
}

int dx[] = { -1, 0, 1, 0 };
int dy[] = { 0, 1, 0, -1 };

void solve() {

    size_t n, m;
    cin >> n >> m;

    vector<vector<vector<int>>> dp(4, vector<vector<int>>(n, vector<int>(m)));

    vector<vector<int>> f(n, vector<int>(m));

    for (size_t i = 0; i < n; i++) {
        string row;
        cin >> row;
        for (size_t j = 0; j < m; j++) {
            char c = row[j];
            f[i][j] = c == '#';
            if (!f[i][j]) {
                for (size_t d = 0; d < 4; d++)
                    dp[d][i][j] = 1;
            }
        }
    }

    for (size_t d = 0; d < 4; d++) { // dir
        for (int x = 0; x < n; x++) {
            for (int y = 0; y < m; y++) {
                if (f[x][y]) continue;
                int xx = x + dx[d], yy = y + dy[d];
                if (!valid(xx, yy, n, m)) continue;
                dp[d][x][y] = max(dp[d][x][y], 1 + dp[d][xx][yy]);
            }
        }
    }

//    for (size_t d = 0; d < 4; d++) { // dir
//        for (int x = 0; x < n; x++) {
//            for (int y = 0; y < m; y++) {
//               cout << dp[d][x][y] << " ";
//            }
//            cout << endl;
//        }
//        cout << endl;
//    }

    int ans = 0;

    for (int x = 0; x < n; x++) {
        for (int y = 0; y < m; y++) {
            int sum = 0;
            for (size_t d = 0; d < 4; d++)
                sum += dp[d][x][y];
            for (size_t d = 0; d < 4; d++)
                ans = max(ans, sum - dp[d][x][y] - 2);
        }
    }

    vector<int> vs, hs;

    int max_v = 0;

    for (int x = 0; x < n; x++) {
//        cout << max_v << " ";
        for (int y = 0; y < m; y++)
            ans = max(ans, max_v + dp[3][x][y]);

        int h = 0;

        for (int y = 0; y < m; y++) {
            max_v = max(max_v, dp[0][x][y]);
            h = max(h, dp[3][x][y]);
        }

        hs.push_back(h);
//        cout << h << " ";
    }
//    cout << endl;

    max_v = 0;

    for (int x = n - 1; x >= 0; x--) {
        for (int y = 0; y < m; y++)
            ans = max(ans, max_v + dp[3][x][y]);

        for (int y = 0; y < m; y++)
            max_v = max(max_v, dp[2][x][y]);
    }

    int max_h = 0;

    for (int y = 0; y < m; y++) {
//        cout << max_h << " ";
        for (int x = 0; x < n; x++)
            ans = max(ans, max_h + dp[0][x][y]);

        int v = 0;

        for (int x = 0; x < n; x++) {
            max_h = max(max_h, dp[3][x][y]);
            v = max(v, dp[0][x][y]);
        }

        vs.push_back(v);
//        cout << v << " ";
    }
//    cout << endl;

    max_h = 0;

    for (int y = m - 1; y >= 0; y--) {
        for (int x = 0; x < n; x++)
            ans = max(ans, max_h + dp[0][x][y]);

        for (int x = 0; x < n; x++)
            max_h = max(max_h, dp[1][x][y]);
    }

    sort(rALL(vs));
    sort(rALL(hs));

    if (m > 1)
        ans = max(ans, vs[0] + vs[1]);

    if (n > 1)
        ans = max(ans, hs[0] + hs[1]);

    cout << ans << endl;
}

int main() {
    cin.tie(0); ios_base::sync_with_stdio(false);

    int t;
    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}