#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

void input() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.setf(ios::fixed);
    cout.precision(10);
#ifdef _DEBUG
    freopen("../src/input.txt", "r", stdin);
    freopen("../src/output.txt", "w", stdout);
#endif
}

const int INF = INT_MAX;

void solve();

enum Dir {
    Left, Right, Up, Down
};

int main() {
    input();
    solve();
    return 0;
}

vector<vector<int>> calc_go(const vector<vector<char>>& a) {
    int n = a.size();
    int m = a[0].size();
    vector<vector<int>> res(n, vector<int> (m));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (a[i][j] == '#') continue;
            if (j == 0) {
                res[i][j] = 1;
            } else {
                res[i][j] = res[i][j - 1] + 1;
            }
        }
    }
    return res;
}

template <typename T>
void mirror_horizontal(vector<vector<T>>& a) {
    for (auto &i : a) {
        reverse(i.begin(), i.end());
    }
}

template <typename T>
void mirror_vertical(vector<vector<T>>& a) {
    reverse(a.begin(), a.end());
}

template <typename T>
void trans(vector<vector<T>>& a) {
    int n = a.size();
    int m = a[0].size();
    vector<vector<T>> res(m, vector<T> (n));
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            res[j][i] = a[i][j];
        }
    }
    a = res;
}

int find2max(const vector<vector<int>>& a) {
    int m1 = 0, m2 = 0;
    int n = a.size();
    int m = a[0].size();
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            int el = a[i][j];
            if (el > m1) {
                m2 = m1;
                m1 = el;
                j += el - 1;
            } else if (el > m2) {
                m2 = el;
                j += el - 1;
            }
        }
    }
    return m1 + m2;
}

bool chkmax(int& a, int b) {
    if (a < b) {
        a = b;
        return true;
    } else {
        return false;
    }
}

int tt(const vector<vector<int>>& left, const vector<vector<int>>& up) {
    int n = left.size();
    int m = left[0].size();
    vector<vector<int>> dp(n, vector<int> (m));

    int ans = -1;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            if (i != 0)
                chkmax(dp[i][j], dp[i - 1][j]);
            if (j != 0) {
                chkmax(dp[i][j], dp[i][j - 1]);
                chkmax(ans, dp[i][j - 1] + up[i][j]);
            }
            chkmax(dp[i][j], left[i][j]);
            //cerr << dp[i][j] << ' ';
        }
        //cerr << endl;
    }
    //cerr << ans << '\n';
    return ans;
}

int subsolve(vector<vector<char>> a) {
    map<Dir, vector<vector<int>>> go;

    go[Left] = calc_go(a);

    mirror_horizontal(a);
    go[Right] = calc_go(a);
    mirror_horizontal(go[Right]);
    mirror_horizontal(a);

    trans(a);
    go[Up] = calc_go(a);
    trans(go[Up]);

    mirror_horizontal(a);
    go[Down] = calc_go(a);
    mirror_horizontal(go[Down]);

    int ans = find2max(go[Right]);
    trans(go[Down]);

    chkmax(ans, tt(go[Left], go[Up]));

    mirror_horizontal(go[Right]);
    mirror_horizontal(go[Down]);
    mirror_vertical(go[Down]);
    mirror_vertical(go[Right]);
    chkmax(ans, tt(go[Right], go[Down]));
    mirror_horizontal(go[Right]);
    mirror_horizontal(go[Down]);
    mirror_vertical(go[Down]);
    mirror_vertical(go[Right]);

    mirror_vertical(go[Down]);
    mirror_vertical(go[Left]);
    chkmax(ans, tt(go[Left], go[Down]));
    mirror_vertical(go[Left]);
    mirror_vertical(go[Down]);

    mirror_horizontal(go[Up]);
    mirror_horizontal(go[Right]);
    chkmax(ans, tt(go[Right], go[Up]));
    mirror_horizontal(go[Up]);
    mirror_horizontal(go[Right]);
    return ans;
}

void solve() {
    int tests;
    cin >> tests;
    for (int test = 0; test < tests; ++test) {
        int n, m;
        cin >> n >> m;
        vector<vector<char>> a(n, vector<char>(m,'?'));
        for (auto &i : a) {
            for (auto &j : i) {
                cin >> j;
            }
        }

        int ans = subsolve(a);
        trans(a);
        chkmax(ans, subsolve(a));
        cout << ans << '\n';
    }
}


//4
//5 5
//#####
//..###
//###.#
//###.#
//###.#
//5 5
//#####
//##..#
//#.###
//#.###
//#.###
//5 5
//#####
//###.#
//###.#
//..#.#
//#####
//5 5
//#####
//#.###
//#.##.
//#.##.
//#####
//
//5
//2 2
//..
//..
//4 5
//###.#
//#....
//.##.#
//#.#.#
//2 1
//.
//.
//2 3
//###
//#.#
//5 4
//##.#
//..#.
//#.#.
//....
//#.##