#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define rsort(a) sort(a, [&](auto c, auto b){return c > b;})

using namespace std;

using ll = long long;
ll inf = (ll)1e10;


void solve2()
{
	ll n, m; cin >> n >> m;
	vector<vector<char>> a(n, vector<char>(m));
	vector<vector<ll>> dppl(n, vector<ll>(m)), dppr(n, vector<ll>(m)), dppd(n, vector<ll>(m)), dppu(n, vector<ll>(m));
	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j) {
			char c; cin >> c;
			a[i][j]=c;
			if (c == '.') {
				dppl[i][j] = j+1;
				dppr[i][j] = j+1;
				dppd[i][j] = i+1;
				dppu[i][j] = i+1;
			}
		}
			
	for (ll i = 0; i < n; ++i)
		for (ll j = 1; j < m; ++j)
			if (dppl[i][j - 1] && dppl[i][j])
				dppl[i][j] = dppl[i][j - 1];

	for (ll i = 0; i < n; ++i)
		for (ll j = m-2; j >= 0; --j)
			if (dppr[i][j + 1] && dppr[i][j])
				dppr[i][j] = dppr[i][j + 1];

	for (ll j = 0; j < m; ++j)
		for (ll i = 1; i < n; ++i)
			if (dppu[i - 1][j] && dppu[i][j])
				dppu[i][j] = dppu[i - 1][j];

	for (ll j = 0; j < m; ++j)
		for (ll i = n-2; i >= 0; --i)
			if (dppd[i + 1][j] && dppd[i][j])
				dppd[i][j] = dppd[i + 1][j];

	vector<vector<ll>> dpl(n, vector<ll>(m,-inf)), dpr(n, vector<ll>(m,-inf)), dpd(n, vector<ll>(m,-inf)), dpu(n, vector<ll>(m,-inf));

	for (ll i = 0; i < n; ++i)
		for (ll j = 0; j < m; ++j)
		 {
			if (j == 0) {
				if (dppl[i][j])
					dpl[i][j] = 1;
			}
			else {
				if (dppl[i][j])
					dpl[i][j] = max(dpl[i][j - 1], (j + 1) - dppl[i][j] + 1);
				else
					dpl[i][j] = dpl[i][j - 1];
			}
		}

	for (ll i = 0; i < n; ++i)
		for (ll j = m-1; j >= 0; --j)
		{
			if (j == m-1) {
				if (dppr[i][j])
					dpr[i][j] = 1;
			}
			else {
				if (dppr[i][j])
					dpr[i][j] = max(dpr[i][j + 1], dppr[i][j]-(j + 1) + 1);
				else
					dpr[i][j] = dpr[i][j + 1];
			}
		}

	for (ll j = 0; j < m; ++j)
		for (ll i = 0; i < n; ++i)
		{
			if (i == 0) {
				if (dppu[i][j])
					dpu[i][j] = 1;
			}
			else {
				if (dppu[i][j])
					dpu[i][j] = max(dpu[i-1][j], (i + 1) - dppu[i-1][j] + 1);
				else
					dpu[i][j] = dpu[i-1][j];
			}
		}

	for (ll j = 0; j < m; ++j)
		for (ll i = n-1; i >= 0; --i)
		{
			if (i == n-1) {
				if (dppd[i][j])
					dpd[i][j] = 1;
			}
			else {
				if (dppd[i][j])
					dpd[i][j] = max(dpd[i + 1][j], dppd[i+1][j] -(i + 1) + 1);
				else
					dpd[i][j] = dpd[i + 1][j];
			}
		}

	ll ans = -inf;


}

ll ans(ll n, ll m, vector<string>& a)
{
	vector<vector<ll>> upmax(n, vector<ll>(m, 0)), downmax(n, vector<ll>(m, 0));


	vector<ll> len(m, 0);

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
				len[j] = 0;
			else
				++len[j];

			if (i < n - 1)
				upmax[i + 1][j] = max(upmax[i][j], len[j]);
		}

	len.assign(m, 0);

	for (int i = n - 1; i >= 0; --i)
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
				len[j] = 0;
			else
				++len[j];

			if (i > 0)
				downmax[i - 1][j] = max(downmax[i][j], len[j]);
		}


	vector<ll> cmax(m, 0);

	vector<ll> clen(2, 0);

	for (int j = 0; j < m; ++j)
	{
		ll last = -1;
		for (int i = 0; i < n; ++i)
		{
			if (a[i][j] == '#')
			{
				clen.push_back(i - last - 1);
				cmax[j] = max(cmax[j], i - last - 1);
				last = i;
			}
		}

		clen.push_back(n - last - 1);
		cmax[j] = max(cmax[j], n - last - 1);
		last = n;
	}

	vector<ll> pcm(m, 0), scm(m, 0);
	pcm[0] = cmax[0];
	scm[m - 1] = cmax[m - 1];
	for (int i = 1; i < m; ++i)
		pcm[i] = max(pcm[i - 1], cmax[i]);

	for (int i = m - 2; i >= 0; --i)
		scm[i] = max(scm[i + 1], cmax[i]);


	vector<ll> rmax(n, 0);

	vector<ll> rlen(2, 0);

	for (int i = 0; i < n; ++i)
	{
		ll last = -1;
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
			{
				rlen.push_back(j - last - 1);
				rmax[i] = max(rmax[i], j - last - 1);
				last = j;
			}
		}

		rlen.push_back(m - last - 1);
		rmax[i] = max(rmax[i], m - last - 1);
		last = m;
	}

	rsort(all(clen));
	rsort(all(rlen));

	ll anscc = clen[0] + clen[1];


	ll ansrr = rlen[0] + rlen[1];

	ll ansrc = 0;
	for (int i = 0; i < n; ++i)
	{
		ll maxc = 0;
		ll last = -1;
		for (int j = 0; j < m; ++j)
		{
			if (a[i][j] == '#')
			{
				ll cans = maxc;
				if (last >= 0)
					cans = max(cans, pcm[last]);
				cans = max(cans, scm[j]);
				maxc = 0;
				ansrc = max(ansrc, cans + j - last - 1);
				last = j;
			}
			else
			{
				maxc = max({ maxc, upmax[i][j], downmax[i][j] });
			}
		}

		ll cans = maxc;
		if (last >= 0)
			cans = max(cans, pcm[last]);
		maxc = 0;
		ansrc = max(ansrc, cans + m - last - 1);
	}

	return max({ ansrc, anscc, ansrr });
}

void solve()
{
	ll n, m; cin >> n >> m;
	vector<string> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];
	
	vector<string> b(m, string(n, '.'));

	for (int i = 0; i < n; ++i)
		for (int j = 0; j < m; ++j)
			b[j][i] = a[i][j];

	cout << max(ans(n, m, a), ans(m, n, b)) << endl;

}

ll mod = 998'244'353;

int main()
{
	ll n; cin >> n;

	vector<string> a(n);
	for (int i = 0; i < n; ++i)
		cin >> a[i];

	ll ans = 1;
	for (int i = 0; i < n; ++i)
	{
		ll cnt = 0;
		ll last = -1;

		for (int j = 0; j < n; ++j)
		{
			if (a[i][j] == '?')
			{

			}
			else if (a[i][j] == '.')
			{
				if (cnt == 0)
				{
					ans *= (j - last);
					ans %= mod;
				}

				last = j;
				cnt = 0;
			}
			else if (a[i][j] == '#')
			{
				++cnt;
				if (cnt == 0)
				{
					ans *= (j - last);
					ans %= mod;
				}
				else if (cnt == 2 && last + 1 != j)
					ans *= 0;
				last = j;
				cnt = 1;
			}
		}

		if (cnt == 0)
		{
			ans *= (n - last);
			ans %= mod;
		}

		last = n;
		cnt = 0;
	}

	for (int i = 0; i < n; ++i)
	{
		ll cnt = 0;
		ll last = -1;

		for (int j = 0; j < n; ++j)
		{
			if (a[j][i] == '?')
			{

			}
			else if (a[j][i] == '.')
			{
				if (cnt == 0)
				{
					ans *= (j - last);
					ans %= mod;
				}

				last = j;
				cnt = 0;
			}
			else if (a[j][i] == '#')
			{
				++cnt;
				if (cnt == 0)
				{
					ans *= (j - last);
					ans %= mod;
				}
				else if (cnt == 2 && last + 1 != j)
					ans *= 0;
				last = j;
				cnt = 1;
			}
		}

		if (cnt == 0)
		{
			ans *= (n - last);
			ans %= mod;
		}

		last = n;
		cnt = 0;
	}

	cout << (ans% mod + mod) % mod << endl;


	return 0;
}