#include <bits/stdc++.h>

#define ll long long
#define fi first
#define se second
#define i128 __int128

const long double PI = acos(-1);
const long double eps = 1e-8;
const int MOD = 1e9 + 7;
const int MOD998 = 998244353;
const int INF = 1e9 + 7;

// #define int ll

using namespace std;

struct node {
	int left, right;
	node * child_left, * child_right;
	int mx;
};

void build (node * res, int l, int r, vector <int> & a) {
	res->left = l; res->right = r;
	if (l == r) {
		res->mx = a[l];
		res->child_left = res->child_right = 0;
	}
	else {
		int m = l + (r - l) / 2;
		if (res->child_left == 0) res->child_left = new node;
		if (res->child_right == 0) res->child_right = new node;
		build(res->child_left, l, m, a);
		build(res->child_right, m + 1, r, a);
		res->mx = max(res->child_left->mx, res->child_right->mx);
	}
}

// void update (node * root, int ind, int x) {
// 	if (ind < root->left || ind > root->right)
// 		return;

// }

int query (node * root, int l, int r) {
	if (r < root->left || l > root->right)
		return -1e9;
	if (l <= root->left && root->right <= r)
		return root->mx;
	int res1 = query(root->child_left, l, r);
	int res2 = query(root->child_right, l, r);
	return max(res1, res2);
}

void solve();

void opt(){
	ios_base::sync_with_stdio(0);
	cin.tie(0);
}
void files(){
	freopen("input.in", "r", stdin);
	freopen("output.out", "w", stdout);
}

vector <node *> root_lr;
vector <node *> root_rl;
vector <node *> root_ud;
vector <node *> root_du;

main() {
	opt();
	root_lr.resize(1e6 + 5);
	root_rl.resize(1e6 + 5);
	root_ud.resize(1e6 + 5);
	root_du.resize(1e6 + 5);
	for (int i = 1; i <= 1e6; ++i)
		root_lr[i] = new node;
	for (int i = 1; i <= 1e6; ++i)
		root_rl[i] = new node;
	for (int i = 1; i <= 1e6; ++i)
		root_ud[i] = new node;
	for (int i = 1; i <= 1e6; ++i)
		root_du[i] = new node;
	// files();
	int T=1;
	cin>>T;
	while (T--) {
		solve();
		// cout << endl;
	}

}

bool do_intersect (pair <int, pair <int, int>> & hor, pair <int, pair <int, int>> & ver) {
	int i_hor = hor.first;
	int l_hor = hor.second.first, r_hor = hor.second.second;

	int i_ver = ver.first;
	int l_ver = ver.second.first, r_ver = ver.second.second;
	if (r_ver < i_hor) return false;
	if (l_ver > i_hor) return false;
	if (r_hor < i_ver) return false;
	if (l_hor > i_ver) return false;
	return true;
}


void solve() {
	int h, w; cin >> h >> w;
	vector <vector <char>> v(h + 2, vector <char> (w + 2));
	for (int i = 1; i <= h; ++i)
	for (int j = 1; j <= w; ++j)
		cin >> v[i][j];

	vector <vector <int>> a_lr(h + 2, vector <int> (w + 2)), a_rl(h + 2, vector <int> (w + 2)), a_ud(w + 2, vector <int> (h + 2)), a_du(w + 2, vector <int> (h + 2));
	for (int i = 1; i <= h; ++i)
	for (int j = 1; j <= w; ++j) {
		if (v[i][j] == '#') a_lr[i][j] = 0;
		else a_lr[i][j] = a_lr[i][j - 1] + 1;
	}

	for (int i = 1; i <= h; ++i)
	for (int j = w; j >= 1; --j) {
		if (v[i][j] == '#') a_rl[i][j] = 0;
		else a_rl[i][j] = a_rl[i][j + 1] + 1;
	}

	for (int j = 1; j <= w; ++j)
	for (int i = 1; i <= h; ++i) {
		if (v[i][j] == '#') a_ud[j][i] = 0;
		else a_ud[j][i] = a_ud[j][i - 1] + 1;
	}

	for (int j = 1; j <= w; ++j)
	for (int i = h; i >= 1; --i) {
		if (v[i][j] == '#') a_du[j][i] = 0;
		else a_du[j][i] = a_du[j][i + 1] + 1;
	}

	// for (auto elem : a_lr) {
	// for (auto elem1 : elem)
	// 	cout << elem1 << " ";
	// cout << endl;
	// }
	// cout << endl;

	// for (auto elem : a_rl) {
	// for (auto elem1 : elem)
	// 	cout << elem1 << " ";
	// cout << endl;
	// }
	// cout << endl;

	// for (auto elem : a_ud) {
	// for (auto elem1 : elem)
	// 	cout << elem1 << " ";
	// cout << endl;
	// }
	// cout << endl;

	// for (auto elem : a_du) {
	// for (auto elem1 : elem)
	// 	cout << elem1 << " ";
	// cout << endl;
	// }
	// cout << endl;

	int global_ans = 0;
	// оба горизонтальные
	vector <pair <int, pair <int, int>>> hors;
	int mx1 = 0, mx2 = 0;
	for (int i = 1; i <= h; i++)
	for (int j = 1; j <= w + 1; j++) {
		if(v[i][j] == '#' || j == w + 1) {
			int r = j - 1;
			int len = a_lr[i][j - 1];
			int l = r - len + 1;
			if (len >= 1) hors.push_back({i, {l, r}});
			if (len > mx2) {
				mx1 = mx2;
				mx2 = len;
			}
			else if (len > mx1) {
				mx1 = len;
			}
		}
	}
	global_ans = mx1 + mx2;
	// cout << "After horizontal: " << global_ans << endl;
	// оба вертикальные
	vector <pair <int, pair <int, int>>> vers;
	mx1 = 0; mx2 = 0;
	for (int j = 1; j <= w; j++)
	for (int i = 1; i <= h + 1; i++) {
		if(v[i][j] == '#' || i == h + 1) {
			int r = i - 1;
			int len = a_ud[j][i - 1];
			int l = r - len + 1;
			if (len >= 1) vers.push_back({j, {l, r}});
			if (len > mx2) {
				mx1 = mx2;
				mx2 = len;
			}
			else if (len > mx1) {
				mx1 = len;
			}
		}
	}
	global_ans = max(global_ans, mx1 + mx2);
	// cout << "After vertical: " << global_ans << endl;

	
	for (int i = 1; i <= h; ++i)
		build(root_lr[i], 1, w, a_lr[i]);
	for (int i = 1; i <= h; ++i)
		build(root_rl[i], 1, w, a_rl[i]);
	for (int j = 1; j <= w; ++j)
		build(root_ud[j], 1, h, a_ud[j]);
	for (int j = 1; j <= w; ++j)
		build(root_du[j], 1, h, a_du[j]);

	// // cout << query(root_lr[2], 4, 5) << endl;
	// // cout << query(root_ud[2], 1, 2 - 1) << " ---------" << endl;
	// // cout << query(root_du[2], 2 + 1, h) << " ---------" << endl;

	for (auto hor : hors)
	for (auto ver : vers) {
		if (do_intersect(hor, ver)) {
			int i = hor.first, j = ver.first;
			int len_ver = ver.second.second - ver.second.first + 1;
			int len_hor = max(query(root_lr[i], 1, j - 1), query(root_rl[i], j + 1, w));
			global_ans = max(global_ans, len_ver + len_hor);
	// 		// cout << "After " << hor.first << " (" << hor.second.first << ", " << hor.second.second << ")" << " and " << ver.first << " (" << ver.second.first << ", " << ver.second.second << ") INTERSECTVERTICAL: " << global_ans << endl;
			
			len_hor = hor.second.second - hor.second.first + 1;
			len_ver = max(query(root_ud[j], 1, i - 1), query(root_du[j], i + 1, h));
			global_ans = max(global_ans, len_ver + len_hor);
	// 		// cout << "After " << hor.first << " (" << hor.second.first << ", " << hor.second.second << ")" << " and " << ver.first << " (" << ver.second.first << ", " << ver.second.second << ") INTERSECTHORIZONTAL: " << global_ans << endl;
		}
		else {
			global_ans = max(global_ans, (hor.second.second - hor.second.first + 1) + (ver.second.second - ver.second.first + 1));
			// cout << "After " << hor.first << " (" << hor.second.first << ", " << hor.second.second << ")" << " and " << ver.first << " (" << ver.second.first << ", " << ver.second.second << ") NOTINTERSECT: " << global_ans << endl;

		}
	}
	cout << global_ans << endl;
}