#include <bits/stdc++.h>

//#pragma GCC optimize "Ofast"
//#pragma GCC target "avx2"
using namespace std;
#define int long long
#define fi first
#define se second
#define all(x) x.begin(), x.end()
#define endl '\n'
const int INF = (int)1e18 + 100;
struct segTree {
    int n;
    vector<int> tree;
    vector<int> p;

    segTree(vector<int> &mas) {
        n = mas.size();
        tree.resize(4 * n, INF);
        p.resize(4 * n, 0);
        build(0, 0, n, mas);
    }

    void build(int id, int l, int r, vector<int> &a) {
        if (r - l == 1) {
            tree[id] = a[l];
            return;
        }
        int m = (r + l) / 2;
        build(id * 2 + 1, l, m, a);
        build(id * 2 + 2, m, r, a);
        tree[id] = min(tree[id * 2 + 1], tree[id * 2 + 2]);
    }

    void push(int id, int l, int r) {
        if (p[id] == 0) {
            return;
        }
        if (tree[id] != INF)
            tree[id] += p[id];
        if (r - l > 1) {
            p[id * 2 + 1] += p[id];
            p[id * 2 + 2] += p[id];
        }
        p[id] = 0;
    }

    int get(int id, int l, int r, int lq, int rq) {
        push(id, l, r);
        if (l >= lq && r <= rq) {
            return tree[id];
        }
        if (l >= rq || r <= lq) {
            return INF;
        }
        int m = (r + l) / 2;
        return min(get(id * 2 + 1, l, m, lq, rq),
                 get(id * 2 + 2, m, r, lq, rq));
    }

    int get(int lq, int rq) {
        return get(0, 0, n, lq, rq);
    }

    void upd(int id, int l, int r, int lq, int rq, int val) {
        push(id, l, r);
        if (l >= lq && r <= rq) {
            p[id] = val;
            push(id, l, r);
            return;
        }
        if (l >= rq || r <= lq) {
            return;
        }
        int m = (l + r) / 2;
        upd(id * 2 + 1, l, m, lq, rq, val);
        upd(id * 2 + 2, m, r, lq, rq, val);
        tree[id] = min(tree[id * 2 + 1], tree[id * 2 + 2]);
    }

    void upd(int lq, int rq, int val) {
        upd(0, 0, n, lq, rq, val);
    }
};


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<int> k(n);
    for (int i = 0;i <n;i++) {
        cin >> k[i];
    }
    vector<int> a(n);
    a[0] = k[0];
    int ans = a[0];
    for (int i = 1 ;i < n ;i++) {
        a[i] = min(a[i-1], k[i]);
        ans += a[i];
    }
    segTree tA = segTree(a);
    segTree tK = segTree(k);
    int nq;
    cin >> nq;
    cout << ans << endl;
    while (nq--) {
        int type;
        cin >> type;
        if (type==1) {
            int pos;
            cin >> pos;
            if (pos == 0 || (tK.get(0,pos) > k[pos])) {
                int mn = tK.get(pos + 1, n);
                if (mn > k[pos]) {
                    tA.upd(pos, n, 1);
                    ans += (n - pos);
                    k[pos]++;
                    tK.upd(pos,pos + 1, 1);
                    cout << ans << endl;
                    continue;
                }
                int left = pos;
                int right = n - 1;
                int mid;
                while (right - left > 1) {
                    mid = (left + right) / 2;
                    int mn = tK.get(pos + 1, mid + 1);
                    if (mn <= k[pos]) {
                        right = mid;
                    } else {
                        left = mid;
                    }
                }
                tA.upd(pos, right, 1);
                ans+=(right - pos);
                k[pos]++;
                tK.upd(pos,pos + 1, 1);
            } else {
                k[pos]++;
                tK.upd(pos,pos + 1, 1);
                cout << ans << endl;
                continue;
            }
        } else {
            int pos;
            cin >> pos;
            if (pos == 0 || (tK.get(0, pos)) >= k[pos]){
                int mn = tK.get(pos + 1, n);
                if (mn >= k[pos]) {
                    tA.upd(pos, n, -1);
                    ans -= (n - pos);
                    k[pos]--;
                    tK.upd(pos, pos + 1, -1);
                    cout << ans << endl;
                    continue;
                }
                int left = pos;
                int right = n-1;
                int mid;
                while (right - left > 1) {
                    mid = (left + right) / 2;
                    int mn = tK.get(pos + 1, mid + 1);
                    if (mn < k[pos]) {
                        right = mid;
                    } else {
                        left = mid;
                    }
                }
                tA.upd(pos, right, -1);
                ans -= (right - pos);
                k[pos]--;
                tK.upd(pos,pos + 1, -1);
            } else {
                k[pos]--;
                tK.upd(pos, pos + 1, -1);
                cout << ans << endl;
                continue;
            }
        }
        cout << ans << endl;
    }
    return 0;
}
