#include <bits/stdc++.h>

using namespace std;

#define int long long

struct SegTree {
    int n;
    vector<int> to_push;
    vector<int> tree;

    explicit SegTree(int n_) : n(n_), to_push(n * 4, 0), tree(n * 4, 0) {}

    void push(int v, int l, int r) {
        tree[v] += to_push[v];
        if (r != l + 1) {
            to_push[v * 2 + 1] += to_push[v];
            to_push[v * 2 + 2] += to_push[v];
        }
        to_push[v] = 0;
    }

    void add(int v, int l, int r, int L, int R, int delta) {
        push(v,l, r);
        if (l >= R || r <= L) {
            return;
        }
        if (l >= L && r <= R) {
            to_push[v] += delta;
            push(v, l, r);
            return;
        }
        int m = (r + l) / 2;
        add(v * 2 + 1, l, m, L, R, delta);
        add(v * 2 + 2, m, r, L, R, delta);
        tree[v] = min(tree[v * 2 + 1], tree[v * 2 + 2]);
    }

    int get_value(int v, int l, int r, int ind) {
        push(v, l, r);
        if (r == l + 1) {
            return tree[v];
        }
        int m = (r + l) / 2;
        if (m > ind) {
            get_value(v * 2 + 1, l, m, ind);
        } else {
            get_value(v * 2 + 2, m, r, ind);
        }

    }

    void add(int l, int r, int delta) {
        add(0, 0, n, l, r, delta);
    }

    int descent(int v, int l, int r) {
        push(v, l, r);
        if (r == l + 1) {
            return l;
        }
        int m = (r + l) / 2;
        push(v * 2 + 1, l, m);
        if (tree[v * 2 + 1] == 0) {
            return descent(v * 2 + 1, l, m);
        } else {
            return descent(v * 2 + 2, m, r);
        }
    }

    int get(int v, int l, int r, int L, int R) {
        push(v, l, r);
        if (l >= R || r <= L) {
            return -1;
        }
        if (l >= L && r <= R) {
            if (tree[v] == 0) {
                return descent(v, l, r);
            } else {
                return -1;
            }
        }
        int m = (r + l) / 2;
        int res = get(v * 2 + 1, l, m, L, R);
        if (res != -1) {
            return res;
        } else {
            return get(v * 2 + 2, m, r, L, R);
        }
    }

    int get_next_zero(int ind) {
        return get(0, 0, n, ind, n);
    }

};

struct ManyMexHolder {
    multiset<int> mexes;
    SegTree t;
    long long ans = 0;

    explicit ManyMexHolder(int n) : t(n + 10) {}

    void add(int x) {
        if (x == 0 || mexes.find(x) != mexes.end()) {
            int right_bound = max(x, t.get_next_zero(x + 1) - 1);
            if (right_bound > x) {
                t.add(x + 1, right_bound + 1, -1);
            }
            ans += right_bound + 1 - x;
            if (x != 0) {
                mexes.erase(mexes.find(x));
            }
            mexes.insert(right_bound + 1);
        } else {
            t.add(x, x + 1, 1);
        }
    }

    void delete_num(int x) {
        if (t.get_value(0, 0, t.n, x) > 0) {
            t.add(x, x + 1, -1);
        } else {
            auto ptr = mexes.upper_bound(x);
            if (ptr == mexes.end()) {
                return;
            }
            int min_mex = *ptr;

            ans -= min_mex - x;
            t.add(x + 1, min_mex, 1);
            mexes.erase(mexes.find(min_mex));
            if (x != 0) {
                mexes.insert(x);
            }
        }
    }

};

void solve() {
    int n;
    cin >> n;
    ManyMexHolder h(n);
    vector<int> a;

    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        a.push_back(x);
    }
    int cur_min = a[0];
    for (int i = 1; i < n; ++i) {
        int prev = cur_min;
        cur_min = min(cur_min, a[i]);
        h.t.add(i, i + 1, a[i] - cur_min);
        for (int j = 0; j < (prev - cur_min); ++j) {
            h.mexes.insert(i);
            h.ans += i;
        }
    }
    for (int i = 0; i < cur_min; ++i) {
        h.mexes.insert(n);
        h.ans += n;
    }
    cout << h.ans << '\n';

    int q;
    cin >> q;
    for (int i = 0; i < q; ++i) {
        int tp;
        cin >> tp;
        int x;
        cin >> x;
        if (tp == 1) {
            h.add(x);
        } else {
            h.delete_num(x);
            exit(0);
        }
        cout << h.ans << '\n';
    }
}

signed main() {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt","r", stdin);
#endif
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
