#include <iostream>
#include <vector>
#include <tuple>
#include <algorithm>
#include <utility>
//     |
//    / \
//   |   |
//   | o |
//   |   |
//  /|   |\
//  ||___||
//  ^^   ^^

using namespace std;
using brick = tuple<long long, long long, long long, bool>;


void new_way(vector<brick> &bricks, brick a) {
    bricks.emplace_back(a);
    sort(bricks.begin(), bricks.end(), [](brick a, brick b) {
        return get<2>(a) > get<2>(b);
    });
}

int main() {
    long long t;
    long long n, m;
    cin >> t;
    for (long long i = 0; i < t; i++) {
        cin >> n >> m;
        char c;
        vector<vector<bool>> location(n, vector<bool>(m));
        for (long long x = 0; x < n; x++) {
            for (long long y = 0; y < m; y++) {
                cin >> c;
                location[x][y] = (c == '#');
            }
        }

        vector<brick> bricks;

        // horizontal
        long long length = 0;
        for (long long x = 0; x < n; x++) {
            for (long long y = 0; y < m; y++) {
                if (location[x][y] == 0) {
                    length += 1;
                } else if (length != 0) {
                    new_way(bricks, {x, y - length, length, 1});
                    length = 0;
                }
            }
            if (length != 0) {
                new_way(bricks, {x, m - length, length, 1});
            }
            length = 0;
        }
        // vertical
        for (long long y = 0; y < m; y++) {
            for (long long x = 0; x < n; x++) {
                if (location[x][y] == 0) {
                    length += 1;
                } else if (length != 0) {
                    new_way(bricks, {x - length, y, length, 0});
                    length = 0;
                }
            }
            if (length != 0) {
                new_way(bricks, {n - length, y, length, 0});
            }
            length = 0;
        }
        long long mxlength = 0;

        for (long long k = 0; k < bricks.size(); k++) {
            for (long long l = k + 1; l < bricks.size(); l++) {
                brick a = bricks[k];
                brick b = bricks[l];
                if (get<3>(a) == get<3>(b)) {
                    mxlength = max(mxlength, get<2>(a) + get<2>(b));
                } else {
                    if (get<3>(a) == 0) {
                        swap(a, b);
                    }
                    // a - horizontal
                    // b - vertical
                    // a[0] -- a[0] + a[2]
                    // b[1]
                    //  --
                    //  --
                    // b[1] + b[2]
                    long long x1a, x2a, y1a, y2a;
                    long long x1b, x2b, y1b, y2b;
                    x1a = get<0>(a);
                    x2a = get<0>(a);
                    y1a = get<1>(a);
                    y2a = get<1>(a) + get<2>(a);

                    x1b = get<0>(b);
                    x2b = get<0>(b) + get<2>(b);
                    y1b = get<1>(b);
                    y2b = get<1>(b);
                    if (x2b < x1a || x2a < x1b || y2b < y1a || y2a < y1b) {
                        mxlength = max(mxlength, get<2>(a) + get<2>(b));
                    } else {
                        // converges at (x1a, y1b)
                        mxlength = max(mxlength, get<2>(a) +
                                                 max(abs(x1a - x1b), abs(x1a - x2b)) - 1);

                        mxlength = max(mxlength, get<2>(b) +
                                                 max(abs(y1b - y1a), abs(y1b - y2a)) - 1);
                    }
                }
            }
        }
        cout << mxlength << endl;
    }
}
