/*
 * Copyright © 6highloads (Shik, Kirsanov, Ushkov)
 * 2022
 */


#include <bits/stdc++.h>
#define fastio ios_base::sync_with_stdio(false), cin.tie(0), cout.tie(0)

using namespace std;

using ll = int64_t;

const int64_t NO_COLOR = -1;

struct TCube {
    TCube() :
    edge0(0),
    edge1(1),
    edge2(2),
    edge3(3),
    edge4(4),
    edge5(5),
    color(6, NO_COLOR) {}

    void rotateFront() {
        int64_t newEdge0 = edge2;
        int64_t newEdge1 = edge1;
        int64_t newEdge2 = edge5;
        int64_t newEdge3 = edge3;
        int64_t newEdge4 = edge0;
        int64_t newEdge5 = edge4;

        edge0 = newEdge0;
        edge1 = newEdge1;
        edge2 = newEdge2;
        edge3 = newEdge3;
        edge4 = newEdge4;
        edge5 = newEdge5;
    }

    void rotateRight() {
        int64_t newEdge0 = edge0;
        int64_t newEdge1 = edge2;
        int64_t newEdge2 = edge3;
        int64_t newEdge3 = edge4;
        int64_t newEdge4 = edge1;
        int64_t newEdge5 = edge5;

        edge0 = newEdge0;
        edge1 = newEdge1;
        edge2 = newEdge2;
        edge3 = newEdge3;
        edge4 = newEdge4;
        edge5 = newEdge5;
    }

    int64_t& bottom() {
        return edge2;
    }

    int64_t& bottomColor() {
        return color[bottom()];
    }

    int64_t edge0;
    int64_t edge1;
    int64_t edge2;
    int64_t edge3;
    int64_t edge4;
    int64_t edge5;
    std::vector<int64_t> color;
};

void print(const std::vector<int64_t>& v) {
    cout << "[ ";
//    for (size_t x : v) {
//        cout << x << " ";
//    }
    cout << v[2] << " " << v[1] << " " << v[0]
         << " " << v[5] << " " << v[3] << " " << v[4];
    cout << "]\n";
    cout.flush();
}

int main() {
    fastio;

    size_t t;
    cin >> t;
    while (t--) {
        size_t n;
        cin >> n;

        vector<vector<int64_t>> color(n, vector<int64_t>(n, NO_COLOR));
        for (int64_t i = 0; i < n; ++i) {
            for (int64_t j = 0; j < n; ++j) {
                cin >> color[i][j];
            }
        }

        vector<vector<vector<TCube>>> field(n, vector<vector<TCube>>(n));
        field[0][0].emplace_back();
        field[0][0][0].bottomColor() = color[0][0];

        for (int64_t i = 0; i < n; ++i) {
            for (int64_t j = 0; j < n; ++j) {
                // rotate front
                if (i - 1 >= 0) {
                    for (TCube& cube : field[i - 1][j]) {
                        TCube rotatedCube = cube;
                        rotatedCube.rotateFront();
                        if (rotatedCube.bottomColor() == NO_COLOR || rotatedCube.bottomColor() == color[i][j]) {
                            rotatedCube.bottomColor() = color[i][j];
//                            print(rotatedCube.color);
                            field[i][j].push_back(rotatedCube);
                        }
                    }
                }

                // rotate right
                if (j - 1 >= 0) {
                    for (TCube& cube : field[i][j - 1]) {
                        TCube rotatedCube = cube;
                        rotatedCube.rotateRight();
                        if (rotatedCube.bottomColor() == NO_COLOR || rotatedCube.bottomColor() == color[i][j]) {
                            rotatedCube.bottomColor() = color[i][j];
//                            print(rotatedCube.color);
                            field[i][j].push_back(rotatedCube);
                        }
                    }
                }
            }
        }

        if (field[n - 1][n - 1].empty()) {
            cout << "No\n";
            continue;
        }

        cout << "Yes\n";
        TCube cube = field[n - 1][n - 1][0];
        cout
        << (cube.color[2] == NO_COLOR ? 0 : cube.color[2]) << " "
        << (cube.color[1] == NO_COLOR ? 0 : cube.color[1]) << " "
        << (cube.color[0] == NO_COLOR ? 0 : cube.color[0]) << " "
        << (cube.color[5] == NO_COLOR ? 0 : cube.color[5]) << " "
        << (cube.color[3] == NO_COLOR ? 0 : cube.color[3]) << " "
        << (cube.color[4] == NO_COLOR ? 0 : cube.color[4]) << "\n";
    }

    return 0;
}
