#define ll long long
// #define x first
// #define y second

#include <bits/stdc++.h>

using namespace std;

#ifndef LOCAL
	#define cerr if(false)cerr
#endif

template<typename T>
ostream& operator<<(ostream& out, vector<T>& v)
{
	for(T& e : v) out << e << " ";

	return out;
}

template<typename T>
ostream& operator<<(ostream& out, pair<T, T>& v)
{
	out << v.x << " " << v.y;

	return out;
}


struct point
{
	int x;
	int y;

	inline point(){
		x = -1;
		y = -1;
	}

	inline point(int x, int y){
		this->x = x;
		this->y = y;
	}
};

struct segment
{

	point begin;
	point end;

	int len = 0;

	inline segment(point &a, point &b){
		begin = a;
		end = b;
		len = max(abs(a.x - b.x), abs(a.y - b.y)) + 1;
	}

	inline segment(){
		len = 0;
		begin = point(-1, -1);
		end = point(-1, -1);
	}

	inline point intersects(segment a){

		if(begin.x == end.x){
			if(begin.x < a.begin.x || begin.x > a.end.x || begin.y > a.end.y || end.y < a.end.y){
				return point(-1, -1);
			} else {
				return point(begin.x, a.begin.y);
			}
		} else {
			if(a.begin.x < begin.x || a.begin.x > end.x || a.begin.y > end.y || a.end.y < end.y){
				return point(-1, -1);
			} else {
				return point(a.begin.x, begin.y);
			}
		}
	}
};

inline bool operator==(point a, point b){
	return a.x == b.x && a.y == b.y;
}

inline bool operator!=(point a, point b){
	return !(a == b);
}

inline bool comp(segment a, segment b){
	return a.len > b.len;
}

inline void solve(){

	// cerr << "SAMPLE " << endl;

	int n, m;
	cin >> n >> m;

	int v[n][m];

	for(int i = 0; i < n; i++){
		for(int j = 0; j < m; j++){
			char c;
			cin >> c;
			if(c == '.'){
				v[i][j] = 0;
			} else {
				v[i][j] = -1;
			}
		}
	}



	vector<segment> vertical;
	vector<segment> horizontal;

	for(int i = 0; i < n; i++){
		point start = point(-1, -1);
		point end = point(-1, -1);
		for(int j = 0; j < m ; j++){
			if(v[i][j] == 0 && start == point(-1, -1)){
				start = point(i, j);
			}
			if((v[i][j] != 0 && start != point(-1, -1))){
				end = point(i, j - 1);	
				horizontal.push_back(segment(start, end));
				start = point(-1, -1);
			} else if(v[i][j] == 0 && start != point(-1, -1) && j == m - 1) {
				end = point(i, j);	
				horizontal.push_back(segment(start, end));
				start = point(-1, -1);
			}
		}
	}


	for(int i = 0; i < m; i++){
		point start = point(-1, -1);
		point end = point(-1, -1);
		for(int j = 0; j < n ; j++){
			if(v[j][i] == 0 && start == point(-1, -1)){
				start = point(j, i);
			}
			if((v[j][i] != 0 && start != point(-1, -1))){
				end = point(j - 1, i);	
				vertical.push_back(segment(start, end));
				start = point(-1, -1);
			} else if((v[j][i] == 0 && start != point(-1, -1) && j == n - 1)){
				end = point(j, i);	
				vertical.push_back(segment(start, end));
				start = point(-1, -1);
			}
		}
	}


	sort(vertical.begin(), vertical.end(), comp);
	sort(horizontal.begin(), horizontal.end(), comp);

	// for(auto at: vertical){
	// 	cerr << at.len << endl;
	// }

	// for(auto at: horizontal){
	// 	cerr << at.len << endl;
	// }


	int ans = 0;
	if(horizontal.size() > 1){
		auto hormax0 = horizontal[0].len;
		auto hormax1 = horizontal[1].len;		
		ans = max(ans, hormax0 + hormax1);
	} else if(horizontal.size() == 1) {
		ans = max(ans, horizontal[0].len);
	}

	if(vertical.size() > 1){
		auto vertmax0 = vertical[0].len;
		auto vertmax1 = vertical[1].len;
		ans = max(ans, (vertmax0 + vertmax1));
	} else if(vertical.size() == 1){
		ans = max(ans, vertical[0].len);
	}


	for(int i = horizontal.size() - 1; i >= 0; i--){
		for(int j = vertical.size() - 1; j >= 0; j--){
			point inter = horizontal[i].intersects(vertical[j]);
			// cerr << "INTER: " << inter.x << ' ' << inter.y << endl;
			if(inter == point(-1, -1)){
				if(horizontal[i].len + vertical[j].len < ans){
					break;
				}
				ans = max(ans, horizontal[i].len + vertical[j].len);
			} else {

				segment a, b;

				a = segment(horizontal[i].begin, horizontal[i].end);
				b = segment(vertical[j].begin, inter);

				ans = max(ans, a.len + b.len - 1);

				a = segment(horizontal[i].begin, horizontal[i].end);
				b = segment(inter, vertical[j].end);				

				ans = max(ans, a.len + b.len - 1);

				a = segment(inter, horizontal[i].end);
				b = segment(vertical[j].begin, vertical[j].end);				

				ans = max(ans, a.len + b.len - 1);

				a = segment(horizontal[i].begin, inter);
				b = segment(vertical[j].begin, vertical[j].end);				

				ans = max(ans, a.len + b.len - 1);

			}
		}
	}


	cout << ans << '\n';

}

signed main(){

	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	#ifdef LOCAL
	freopen("test.in", "r", stdin);
	freopen("test.out", "w", stdout);
	#endif

	int t;
	cin >> t;

	while(t--) solve();

	return 0;
}