#include <iostream>
#include <set>
#include <deque>
#include <algorithm>
#include <vector>

using namespace std;

int get_cross(vector<int> a)
{
	sort(a.begin(), a.end());
	return a[3] + a[2] + 1;
}



vector<int> get_max(vector<vector<int>>& w, int a, int b)
{
	vector<vector<vector<int>>> cross(a, vector<vector<int>>(b, vector<int>(4, 0)));
	for (int i = 0; i < a; i++)
	{
		for (int j = 0; j < b; j++)
		{
			if (i != 0 && w[i - 1][j] == '.' && w[i][j] == '.') cross[i][j][0] += cross[i - 1][j][0] + 1;
			if (j != 0 && w[i][j - 1] == '.' && w[i][j] == '.') cross[i][j][1] += cross[i][j - 1][1] + 1;
		}
	}
	int maxcross = 0;
	int maxhor = 0, maxhori = 0, maxhorj = 0;
	int maxver = 0, maxveri = 0, maxverj = 0;
	for (int i = a - 1; i > -1; i--)
	{
		for (int j = b - 1; j > -1; j--)
		{
			if (i != a - 1 && w[i + 1][j] == '.' && w[i][j] == '.') cross[i][j][2] += cross[i + 1][j][2] + 1;
			if (j != b - 1 && w[i][j + 1] == '.' && w[i][j] == '.') cross[i][j][3] += cross[i][j + 1][3] + 1;
			maxcross = max(maxcross, get_cross(cross[i][j]));
			if (maxhor <= cross[i][j][0] + cross[i][j][2] + 1 && w[i][j] == '.')
			{
				maxhor = cross[i][j][0] + cross[i][j][2] + 1;
				maxhori = i;
				maxhorj = j;
			}
			if (maxver <= cross[i][j][1] + cross[i][j][3] + 1 && w[i][j] == '.')
			{
				maxver = cross[i][j][1] + cross[i][j][3] + 1;
				maxveri = i;
				maxverj = j;
			}
		}
	}
	return { maxcross, maxhor, maxhori, maxhorj, maxver, maxveri, maxverj };
}
int main() {
	int t; cin >> t;
	for (int it = 0; it < t; it++)
	{
		int a, b; cin >> a >> b;
		vector<vector<int>> w(a, vector<int>(b));
		for (int i = 0; i < a; i++)
		{
			string s; cin >> s;
			for (int j = 0; j < b; j++)
			{
				w[i][j] = s[j];
			}
		}
		vector<vector<vector<int>>> cross(a, vector<vector<int>>(b, vector<int>(4, 0)));
		vector<int> res = get_max(w, a, b);
		int maxcross = res[0];
		int maxhor = res[1], maxhori = res[2], maxhorj = res[3];
		int maxver = res[4], maxveri = res[5], maxverj = res[6];

		auto w1 = w;
		for (int i = maxhori; i < maxhori + maxhor && i<a; i++)
			w1[i][maxhorj] = '#';

		vector<int> res1 = get_max(w1, a, b);
		int maxcross1 = res1[0];
		int maxhor1 = res1[1], maxhori1 = res1[2], maxhorj1 = res1[3];
		int maxver1 = res1[4], maxveri1 = res1[5], maxverj1 = res1[6];

		auto w2 = w;
		for (int j = maxverj; j < maxverj + maxver && j<b; j++)
			w2[maxveri][j] = '#';

		vector<int> res2 = get_max(w2, a, b);
		int maxcross2 = res2[0];
		int maxhor2 = res2[1], maxhori2 = res2[2], maxhorj2 = res2[3];
		int maxver2 = res2[4], maxveri2 = res2[5], maxverj2 = res2[6];
		/*
		for (auto i : w1)
		{
			for (auto j : i) cout << char(j) << "";
			cout << endl;
		}
		cout << endl;
		for (auto i : w2)
		{
			for (auto j : i) cout << char(j) << "";
			cout << endl;
		}
		cout << endl;
		cout << maxcross << " " << maxhor << " " << maxhor << " " << maxver << endl;
		cout << maxcross << " " << maxhor << " " << maxhor1 << " " << maxver1 << endl;
		cout << maxcross << " " << maxhor << " " << maxhor2 << " " << maxver2 << endl;*/
		int sum1 = maxhor + max(maxhor1, maxver1);
		int sum2 = maxver + max(maxhor2, maxver2);
		int sum3 = max(sum1, sum2);
		cout << max(maxcross, sum3) << endl;
	}

}