#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct hole {
    long long len = 0, line{}, beg{}, en{};
};

bool cmp(hole h1, hole h2) {
    return h1.len > h2.len;
}

long long int hor_2(const vector<struct hole> &horiz) {
    if (horiz.empty()) {
        return 0;
    }
    if (horiz.size() == 1) {
        return horiz[0].len;
    }
    return horiz[0].len + horiz[1].len;
}

long long int vert_2(const vector<struct hole> &vert) {
    if (vert.empty()) {
        return 0;
    }
    if (vert.size() == 1) {
        return vert[0].len;
    }
    return vert[0].len + vert[1].len;
}

long long int hor_vert(const vector<struct hole> &horiz, const vector<struct hole> &vert) {
    long long mx = 0;
    for (auto &i: horiz) {
        for (auto &j: vert) {
            if (i.line > j.en || i.line < j.beg || j.line < i.beg || j.line > i.en) {
                mx = max(mx, i.len + j.len);
            } else {
                mx = max(mx, i.len + max(i.line - j.beg, j.en - i.line));
                mx = max(mx, j.len + max(j.line - i.beg, i.en - j.line));
            }
        }
    }
    return mx;
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<char> > v(n, vector<char>(m));
    vector<hole> vert, horiz;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            cin >> v[i][j];
        }
    }
    hole h;
    bool flag;
    for (int i = 0; i < n; i++) {
        flag = false;
        for (int j = 0; j < m; j++) {
            h.line = i;
            if (v[i][j] == '.') {
                if (j == 0 || v[i][j - 1] == '#') {
                    h.beg = j;
                }
                flag = true;
            } else if (flag) {
                h.en = j - 1;
                h.len = h.en - h.beg + 1;
                horiz.push_back(h);
                flag = false;
            }
        }
        if (v[i][m - 1] != '#') {
            h.en = m - 1;
            h.len = h.en - h.beg + 1;
            horiz.push_back(h);
        }
    }
    for (int j = 0; j < m; j++) {
        flag = false;
        for (int i = 0; i < n; i++) {
            h.line = j;
            if (v[i][j] == '.') {
                if (i == 0 || v[i - 1][j] == '#') {
                    h.beg = i;
                }
                flag = true;
            } else if (flag) {
                h.en = i - 1;
                h.len = h.en - h.beg + 1;
                vert.push_back(h);
                flag = false;
            }
        }
        if (v[n - 1][j] != '#') {
            h.en = n - 1;
            h.len = h.en - h.beg + 1;
            vert.push_back(h);
        }
    }

    /*for (int i = 0; i < horiz.size(); i++)
{
    cout << horiz[i].line << ' ' << horiz[i].beg << ' ' << horiz[i].en << endl;
}

cout << "*************" << endl;

for (int i = 0; i < vert.size(); i++)
{
    cout << vert[i].line << ' ' << vert[i].beg << ' ' << vert[i].en << endl;
}*/

    sort(horiz.begin(), horiz.end(), cmp);
    sort(vert.begin(), vert.end(), cmp);
    cout << max(hor_2(horiz), max(vert_2(vert), hor_vert(horiz, vert))) << endl;
}

int main() {
    long long test;
    cin >> test;
    for (int k = 0; k < test; k++) {
        solve();
    }
}


/*

5
2 2
..
..
4 5
###.#
#....
.##.#
#.#.#
2 1
.
.
2 3
###
#.#
5 4
##.#
..#.
#.#.
....
#.##

*/
