#include <bits/stdc++.h>

using buf_t = std::vector<std::vector<char>>;

struct line {
    int l;
    int x0;
    int y0;
};

line maxhline (buf_t &buf, int w, int h)
{
    int maxw = 0;
    int x0, y0;
    for (int y = 0; y < h; ++y) {
        int curw = 0;
        int curx0, cury0;
        for (int x = 0; x < w; ++x) {
            if (buf[y][x] == '.') {
                if (curw == 0) {
                    curx0 = x;
                    cury0 = y;
                }
                curw += 1;
            } else {
                if (curw > maxw) {
                    maxw = curw;
                    x0 = curx0;
                    y0 = cury0;
                }
                curw = 0;
            }
        }
        if (curw > maxw) {
            maxw = curw;
            x0 = curx0;
            y0 = cury0;
        }
    }
    return line { maxw, x0, y0 };
}

line maxvline (buf_t &buf, int w, int h)
{
    int maxw = 0;
    int x0, y0;
    for (int x = 0; x < w; ++x) {
        int curw = 0;
        int curx0, cury0;
        for (int y = 0; y < h; ++y) {
            if (buf[y][x] == '.') {
                if (curw == 0) {
                    curx0 = x;
                    cury0 = y;
                }
                curw += 1;
            } else {
                if (curw > maxw) {
                    maxw = curw;
                    x0 = curx0;
                    y0 = cury0;
                }
                curw = 0;
            }
        }
        if (curw > maxw) {
            maxw = curw;
            x0 = curx0;
            y0 = cury0;
        }
    }
    return line { maxw, x0, y0 };
}

void eraseh(buf_t &buf, line l, char c)
{
    for (int dx = 0; dx < l.l; ++dx) {
        buf[l.y0][l.x0+dx] = c;
    }
}

void erasev(buf_t &buf, line l, char c)
{
    for (int dx = 0; dx < l.l; ++dx) {
        buf[l.y0+dx][l.x0] = c;
    }
}

int main ()
{
    std::ios_base::sync_with_stdio(false);

    int t;
    scanf("%d", &t);

    for (int test = 0; test < t; ++test) {
        int w, h;
        scanf("%d %d\n", &h, &w);

        buf_t buf (h, std::vector<char>(w+2));
        for (int y = 0; y < h; ++y) {
            fgets(buf[y].data(), w+2, stdin);
        }

        line maxw = maxhline(buf, w, h);
        line maxh = maxvline(buf, w, h);

        eraseh(buf, maxw, '1');
        line maxww = maxhline(buf, w, h);
        line maxwh = maxvline(buf, w, h);
        eraseh(buf, maxw, '.');

        erasev(buf, maxh, '1');
        line maxhw = maxhline(buf, w, h);
        line maxhh = maxvline(buf, w, h);
        erasev(buf, maxh, '.');

        auto res = std::max(
                std::max(maxw.l + maxww.l,
                         maxw.l + maxwh.l),
                std::max(maxh.l + maxhw.l,
                         maxh.l + maxhh.l)
        );
        printf("%d\n", res);
    }

    return 0;
}
