#include <iostream>
#include <algorithm>
#include <set>
#include <vector>

using namespace std;

int n;
int cnt = 0;

struct Config {
    int *a;
    long long hash;
    Config(int n) {
        a = new int[n];
    }
    long long cntHash() {
        int mult = 37;
        long long p = 1;
        int mod = 1e9 + 7;
        long long sum = 0;
        for (int i = 0; i < n; i++) {
            sum += a[i] * p;
            sum %= mod;
            p = (p * mult) % mod;
        }
        hash = sum;
    }
};
Config *final;
vector <pair<int, Config*> > path;
set <long long> curConfigs;

struct Element {
    Config *config;
    int index;
    int depth;
    vector <Element*> next;
    Element* prev;
};

Element* createElem(Element *prev, Config *config) {
    auto *elem = new Element();
    elem->prev = prev;
    elem->config = config;
    if (prev != NULL)
        elem->depth = prev->depth + 1;
    return elem;
}

bool eq(Config *a, Config *b) {
    return a->hash == b->hash;
}

Config *copy(Config *a) {
    auto *ret = new Config(n);
    for (int i = 0; i < n; i++) {
        ret->a[i] = a->a[i];
    }
    return ret;
}

bool existsInConfigs(Config *conf) {
    return curConfigs.count(conf->hash) > 0;
}

int calc(Config *conf, int depth) {
    Config *next = copy(conf);

    for (int i = 0; i < n - 1; i++) {
        int razn = abs(next->a[i] - next->a[i + 1]);
        if (razn <= 1)
            continue;

        swap(next->a[i], next->a[i + 1]);
        next->cntHash();
        if (existsInConfigs(next)) {
            swap(next->a[i], next->a[i + 1]);
            continue;
        }
        path.push_back({i, next});
        curConfigs.insert(next->hash);
        cnt++;
        if (cnt > 100) return -1;

        if (eq(next, final)) return depth;

        int result = calc(next, depth + 1);
        if (result != -1)
            return result;
        swap(next->a[i], next->a[i + 1]);
        path.pop_back();
    }
    return -1;
}

Element* calc2(Element *element) {
    if (element->depth > 20000) return NULL;
    Config *conf = element->config;

    for (int i = 0; i < n - 1; i++) {
        int razn = abs(conf->a[i] - conf->a[i + 1]);
        if (razn <= 1)
            continue;

        Config *next = copy(conf);
        Element *nextElem = createElem(element, next);
        nextElem->index = i;
        swap(next->a[i], next->a[i + 1]);
        next->cntHash();
        if (existsInConfigs(next)) {
            swap(next->a[i], next->a[i + 1]);
            continue;
        }

        curConfigs.insert(next->hash);

        if (eq(next, final)) return nextElem;
        Element* result = calc2(nextElem);
        if (result != NULL)
            return result;
        swap(next->a[i], next->a[i + 1]);
    }
    return NULL;
}

int main() {
    cin >> n;
    auto* init = new Config(n);
    for (int i = 0; i < n; i++)
        cin >> init->a[i];
    init->cntHash();
    Element *initElem = createElem(NULL, init);
    curConfigs.insert(init->hash);

    final = new Config(n);
    for (int i = 0; i < n; i++)
        cin >> final->a[i];
    final->cntHash();

    Element* result = calc2(initElem);

    vector <int> index;
    Element *path = result;
    while (path != NULL) {
        index.push_back(path->index);
//        for (int i = 0; i < n; i++)
//            cout << path->config->a[i] << " ";
//        cout << endl;
        path = path->prev;
    }
    reverse(index.begin(), index.end());
    if (index.empty()) {
        cout << "-1";
        return 0;
    }
    cout << index.size() << endl;
    for (int i : index)
        cout << i + 1 << " ";
}
